# -*- coding:utf-8 -*-
#---------------------------------------------------------------------
#
# Visor Geogrfico
# Copyright (C) 2009 Germn Carrilo (GeoTux)
#
#---------------------------------------------------------------------
#
# licensed under the terms of GNU GPL 2
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this software. If not, see <http://www.gnu.org/licenses/>.
#
#---------------------------------------------------------------------

import imp, os, fileinput
from PyQt4.QtGui import QMenu

from dialogos.qgisInterface import QgisInterface

class Plugins():
    """ Clase para cargar plugins a la aplicacin principal """
    def __init__( self, miApp, canvas ):
        self.qgisInterface = QgisInterface( miApp, canvas )
        self.miApp = miApp

        self.miApp.menuPlugins = None
        self.plugins = []
        self.cargarPlugins()

    def cargarPlugins( self ):
        """ Valida que exista una carpeta Plugins y carga los plugins a la aplicacin """
        dir_plugins = os.path.join( os.path.abspath( '' ), 'plugins' )

        if os.path.exists( dir_plugins ):
            for root, dirs, files in os.walk( dir_plugins ):
                bPlugIn = False

                if not dir_plugins == root: # Subdirectorios en la carpeta Plugins
                    if '__init__.py' in files: # Filtra carpetas de Plugins

                        # Verificar que el archivo __init__.py corresponda a un plugin
                        for line in fileinput.input( os.path.join( root, '__init__.py' ) ):
                            linea = line.strip()
                            if linea == ("def classFactory(iface):") or linea == "def classFactory( iface ):":
                                bPlugIn = True
                                break
                        fileinput.close()

                        if bPlugIn:
                            if not self.miApp.menuPlugins:
                                self.crearMenuPlugins()
                                print "+----------------=== PLUGINS CARGADOS ===----------------+"

                            # Cargar el plugin
                            nombre_plugin = os.path.basename( root )
                            print ' * ',nombre_plugin,':',
                            f, filename, description = imp.find_module( nombre_plugin, [ 'plugins' ] )

                            try: # Cargar e inicializar el plugin
                                paquete = imp.load_module( nombre_plugin, f, filename, description )
                                self.plugins.append( paquete.classFactory( self.qgisInterface ) )
                            except Exception, e:
                                print '    ERROR!:',e
                            else:
                                self.plugins[ -1 ].initGui()
                                print '    OK!'
        else:
            print "No se encontr la carpeta de Plugins."

    def crearMenuPlugins( self ):
        """ Crea el men Plugins en la barra de mens """
        self.miApp.menuPlugins = QMenu( "&Plugins", self.miApp.menuBar )
        actions = self.miApp.menuBar.actions()
        lastAction = actions[ len( actions ) - 1 ]
        self.miApp.menuBar.insertMenu( lastAction, self.miApp.menuPlugins )
