#==============================================================
#=================== Find by Attribute ========================
#=================== a QGis Plug-In    ========================
#==============================================================

# v0.1 by Mauricio de Paulo 
# v0.2 by Anita Graser
# Update for v0.2 for QGIS 1.0 Preview by Mauricio de Paulo
# v0.3 by Anita Graser


import os,sys

sys.path.append("~/.qgis/python")

from PyQt4.QtCore import *
from PyQt4.QtGui import *


from qgis.core import *

from ui_control import ui_Control
import resources

class findbyattr:

    def __init__(self, iface):
        self.iface = iface
        
    def initGui(self):
        # create action that will start plugin configuration
        self.action = QAction(QIcon(":find.png"), "Find by Attribute", self.iface.mainWindow())
        self.action.setWhatsThis("Find by Attribute")
        QObject.connect(self.action, SIGNAL("activated()"), self.run)
    
        # add toolbar button and menu item
        self.iface.addToolBarIcon(self.action)
        self.iface.addPluginToMenu("&Find by Attribute", self.action)

    def unload(self):
        # remove the plugin menu item and icon
        self.iface.removePluginMenu("&Find by Attribute",self.action)
        self.iface.removeToolBarIcon(self.action)
    
    def run(self):
        # create and show a configuration dialog or something similar
        flags = Qt.WindowTitleHint | Qt.WindowSystemMenuHint | Qt.WindowMaximizeButtonHint  # QgisGui.ModalDialogFlags
        self.pluginGui = ui_Control(self.iface.mainWindow(), flags)
        
        # insert every signal connection here!
        QObject.connect(self.pluginGui.layerComboBox,SIGNAL('currentIndexChanged (int)'),self.readLayerColumns)
        QObject.connect(self.pluginGui.buttonBox,SIGNAL("accepted()"),self.findFeatures)

        self.layermap=QgsMapLayerRegistry.instance().mapLayers()
        for (name,layer) in self.layermap.iteritems():
            self.pluginGui.layerComboBox.addItem(name)
        
	self.pluginGui.operatorComboBox.addItems(["=",">","<",">=","<=","between"])
	
        self.pluginGui.show()

    
    #Now these are the SLOTS
    def updateText(self,args):
        print 'got here'
    def readLayerColumns(self,args):
	print "readLayerColumns"
        vectorlayer=self.layermap[self.pluginGui.layerComboBox.currentText()]
        provider=vectorlayer.dataProvider()
        fieldmap=provider.fields()
	self.pluginGui.attributeComboBox.clear()
        for (k,attr) in fieldmap.iteritems():
            self.pluginGui.attributeComboBox.addItem(attr.name())
    
    def findFeatures(self):
        vectorlayer=self.layermap[self.pluginGui.layerComboBox.currentText()]
        column=self.pluginGui.attributeComboBox.currentText()
        value=self.pluginGui.lineEdit.text()
        provider=vectorlayer.dataProvider()
        provider.rewind()
        f=QgsFeature()
        fieldmap=provider.fields()
        for (k,attr) in fieldmap.iteritems():      
            if (column==attr.name()): 
		 col=k
        allAttrs = provider.attributeIndexes()
        provider.select(allAttrs)
        selection=[]
	operator=self.pluginGui.operatorComboBox.currentText()
	
	if operator not in ("=","between"):
	    try:
	      value=float(value)
	    except:
	      infoString = QString("Error: Non numeric value!")
              QMessageBox.information(self.iface.mainWindow(),"Find by Attribute",infoString)
	      vectorlayer.setSelectedFeatures([])
	      return
	
  # =
	if operator == "=":
          values=value.split(';') #allows to specify a list of values devided by semi-colons 
       	  while (provider.nextFeature(f)):
            fieldmap=f.attributeMap()
            if fieldmap[col].toString() in values:
                selection.append(f.id())
  # >
	elif operator == ">":
       	  while (provider.nextFeature(f)):
            fieldmap=f.attributeMap()
	    try:
	      field=float(fieldmap[col].toString())
              if field > value:
                selection.append(f.id())
	    except:
	      print "Error: Non numeric values!"
  # <
	elif operator == "<":
       	  while (provider.nextFeature(f)):
            fieldmap=f.attributeMap()
	    try:
	      field=float(fieldmap[col].toString())
              if field < value:
                selection.append(f.id())
	    except:
	      print "Error: Non numeric values!"
  # >=
	elif operator == ">=":
       	  while (provider.nextFeature(f)):
            fieldmap=f.attributeMap()
	    try:
	      field=float(fieldmap[col].toString())
              if field >= value:
                selection.append(f.id())
	    except:
	      print "Error: Non numeric values!"
  # <=
	elif operator == "<=":
       	  while (provider.nextFeature(f)):
            fieldmap=f.attributeMap()
	    try:
	      field=float(fieldmap[col].toString())
              if field <= value:
                selection.append(f.id())
	    except:
	      print "Error: Non numeric values!"
  # between
	elif operator == "between":
          values=value.split(';')
       	  while (provider.nextFeature(f)):
            fieldmap=f.attributeMap()
	    try:
	      field=float(fieldmap[col].toString())
              if field >= float(values[0]) and field <= float(values[1]):
                selection.append(f.id())
	    except:
	      print "Error: Non numeric values!"  
    

        vectorlayer.setSelectedFeatures(selection)
	
	count=len(selection)
	
	infoString = QString("Found "+str(count)+" features!")
        QMessageBox.information(self.iface.mainWindow(),"Find by Attribute",infoString)
	
	